Dva pristupnika konfigurirana istim unaprijed dijeljenim ključem dovrše rukovanje, a snimka paketa ne pokazuje nijednu tajnu koja prelazi žicu. To je dio kojeg se ljudi sjećaju. Zanimljiv je dio ono što svaka verzija zapravo izračunava da dokaže da je tajna poznata, jer IKEv1 i IKEv2 grade taj dokaz iz različitih ulaza i pritom otkrivaju različite informacije. Pročitajte dva zapisa jedan uz drugi i razlika prestaje biti kozmetička.

Što dokaz mora postići

Diffie-Hellman daje objema stranama zajedničku vrijednost čije javne polovice može izračunati i svatko tko promatra. Sama po sebi to ne dokazuje ništa o identitetu: napadač koji dovrši razmjenu ključeva ima istu zajedničku vrijednost kao vaš pristupnik. Korak autentikacije postoji da tu razmjenu veže uz tajnu koju imaju samo predviđene strane, te uz identitete i parametre o kojima su se dogovorile.

Upravo je to povezivanje razlog zašto hash pokriva više od ključa. Da pokriva samo tajnu, napadač bi ga mogao ponoviti u drugoj razmjeni s drugim identitetima ili prijedlozima.

IKEv1 Main Mode: izvesti SKEYID i zatim ga dokazati

Main Mode izvodi šest poruka. Prvi par pregovara sigurnosnu asocijaciju, drugi razmjenjuje javne Diffie-Hellman vrijednosti i nonce, a treći nosi identitete i autentikacijske hashove pod upravo uspostavljenim šifriranjem. RFC 2409 definira konstrukciju: uz autentikaciju unaprijed dijeljenim ključem, SKEYID se izvodi iz tajne i oba noncea, a kasniji ključni materijal iz SKEYID-a, zajedničke Diffie-Hellman vrijednosti, kolačića i konstanti.

Hash u petoj i šestoj poruci računa se preko Diffie-Hellman vrijednosti, dva kolačića, prijedloga i identiteta pošiljatelja, s SKEYID-om kao ključem. Primatelj ga ponovno izračuna sa svojom konfiguriranom tajnom. Neslaganje prekida razmjenu i tajna nikada nije nosivi teret.

Aggressive Mode sabija isti posao u tri poruke, što znači da identiteti i autentikacijski hash putuju prije nego što šifrirani kanal postoji. To je stvarna izloženost kada je tajna pogodiva, i odvojeno je od pitanja je li tajna prenesena. IKEv1 je prema RFC 9395 zastario, pa je stari zapis dijagnostička vježba, a ne cilj uvajanja.

IKEv2: druga izvedba i drugi AUTH teret

IKEv2 ne koristi isti raspored ključeva kao IKEv1. Početni IKE ključevi dolaze iz sjemena sastavljenog od noncea i zajedničke Diffie-Hellman vrijednosti, a podređene sigurnosne asocijacije izvode se iz njega. Unaprijed dijeljeni ključ uopće ne ulazi u sjeme.

Autentikacija se zatim pojavljuje kao AUTH teret. Za autentikaciju zajedničkim ključem RFC 7296 propisuje podstavljenu formu tajne, dobivenu hashiranjem tajne s fiksnim nizom Key Pad for IKEv2, a zatim hashiranjem potpisanih podataka razmjene i identiteta tim podstavljenim ključem. Provjeravatelj može obnoviti istu vrijednost; promatrač ne može, bez tajne.

Primijetite što se promijenilo. U IKEv1 je tajna ugrađena u raspored ključeva prije nego autentikacijski hash uopće postoji; u IKEv2 je raspored ključeva neovisan o tajni, a dokaz je zaseban teret vezan uz potpisane oktete. Isto konceptualno jamstvo, drugi stroj, i zato se nazivi parametara i snimke ne preslikavaju jedan na jedan.

Što promatrač zapravo nauči

Javne Diffie-Hellman vrijednosti, prijedlozi, noncei i kolačići vidljivi su u obje verzije. Identiteti su vidljivi u IKEv1 Aggressive Mode, a u ostalim su slučajevima zaštićeni. Tajna nikada nije vidljiva.

Ta zadnja rečenica ima granicu koju vrijedi izreći. Slaba tajna koju odabere čovjek može se napasti pogađanjem: napadač izračuna kakva bi autentikacijska vrijednost bila za kandidatnu tajnu i usporedi. IKEv1 Aggressive Mode to čini najjeftinijim jer je dokaz u čistom tekstu, a standardi općenito upozoravaju na tajne niske entropije. Nikad ne poslati tajnu nije isto što i učiniti lošu tajnu sigurnom.

Što učiniti s usporedbom

Koristite jednu jedinstvenu tajnu po paru strana, generirajte je iz slučajnog izvora i rotirajte je istim putem za pripremu koji ju je distribuirao. Ako je tajna u predlošku konfiguracije koji se šalje u svaku podružnicu, kompromis na jednom mjestu kompromis je svugdje.

Prednost dajte autentikaciji temeljenoj na certifikatima gdje su operativni troškovi prihvatljivi, jer uklanja problem pogađanja zajedničke tajne i daje svakoj strani zaseban identitet. Gdje unaprijed dijeljeni ključ ostaje, držite ga dugim, usko ograničenim i tretirajte verziju IKE-a kao sigurnosnu odluku, a ne kao pojedinost interoperabilnosti.

Povezani članci